"""Describes all the resources."""

from vector2d import *

spritesheets_specs = {
    # Format is
    #"spritesheet_filename.png": {
    #    "sprite_name": (x, y, width, height, origin_x, origin_y),
    #    ...
    #}
    # You can leave out the origin_x and origin_y, in which case it defaults to
    # the top left of the sprite.
    
    "spritesheet_music.png": {
        "double_sixteenth" : (0,  0, 9, 13, 4.5, 6.5),
        "down_eighth" :      (10, 0, 4, 12, 2,   6),
        "up_eighth" :        (15, 0, 4, 12, 2,   6),
        "quarter" :          (20, 0, 4, 12, 2,   6),
        "half" :             (25, 0, 6, 12, 3,   6),
        "sixteenth" :        (32, 0, 6, 12, 3,   6)
    },    
    
    "spritesheet_john.png": {
        "john_norm" : (0, 0, 35, 42, 17, 21),
        "john_hurt" : (36, 0, 35, 42, 17, 21)
    },
    
    "spritesheet_guitar.png": {
        "guitar_norm": (0, 0, 80, 81, 40, 40),
        "guitar_fire": (81, 0, 80, 81, 40, 40)
    },
    
    "spritesheet_sitar.png": {
        "sitar_norm": (0, 0, 80, 81, 40, 40),
        "sitar_fire": (81, 0, 80, 81, 40, 40)
    },
    
    "spritesheet_bass.png": {
        "bass_norm": (0, 0, 80, 81, 40, 40),
        "bass_fire": (81, 0, 80, 81, 40, 40)
    },
    
    "spritesheet_vocal.png": {
        "vocal_norm": (0, 0, 80, 81, 40, 40),
        "vocal_fire": (81, 0, 80, 81, 40, 40)
    },
    
    "map.png" : { "map": (0, 0, 800, 600) },
    "no_fun_splash.png" : { "no_fun": (0, 0, 225, 350, 112, 175) },
    "norwegian_wood.png" : { "norwegian_wood": (0, 0, 454, 75, 227, 37) },
    "instructions.png" : { "instructions": (0, 0, 621, 432, 310, 205) },
    "press_enter.png" : { "press_enter": (0, 0, 211, 23, 105, 12) },
    "axis.png" : { "axis": (0, 0, 600, 250) },
    "local_scores.png" : { "local_scores": (0, 0, 324, 50, 162, 25) },
    "global_scores.png" : { "global_scores": (0, 0, 340, 50, 170, 25) },
    "credits.png" : { "credits": (0, 0, 800, 600, 400, 300) },
    "dodge.png" : { "dodge": (0, 0, 52, 26, 26, 13) },
    "score.png" : { "score": (0, 0, 61, 20) },
    "enter_name.png" : { "enter_name": (0, 0, 216, 29) },
}

animations_specs = {
    # Format is
    #"animation_name": [
    #    ("sprite_name", frame_duration),
    #    ...
    #]
    # The frame duration is in frames (1/60th of a second)
    
    "double_sixteenth": [("double_sixteenth", 1)],
    "down_eighth": [("down_eighth", 1)],
    "up_eighth": [("up_eighth", 1)],
    "quarter": [("quarter", 1)],
    "half": [("half", 1)],
    "sixteenth": [("sixteenth", 1)],
    
    "john_norm": [("john_norm", 1)],
    "john_hurt": [
        ("john_hurt", 7),
        ("john_norm", 7),
    ],

    "guitar_norm": [("guitar_norm", 1)],
    "guitar_fire": [("guitar_fire", 1)],
    
    "sitar_norm": [("sitar_norm", 1)],
    "sitar_fire": [("sitar_fire", 1)],
    
    "bass_norm": [("bass_norm", 1)],
    "bass_fire": [("bass_fire", 1)],
    
    "vocal_norm": [("vocal_norm", 1)],
    "vocal_fire": [("vocal_fire", 1)],
        
    "no_fun": [("no_fun", 1)],
    "norwegian_wood": [("norwegian_wood", 1)],
    "instructions": [("instructions", 1)],
    "press_enter": [("press_enter", 1)],
    "axis": [("axis", 1)],
    "local_scores": [("local_scores", 1)],
    "global_scores": [("global_scores", 1)],
    "credits": [("credits", 1)],
    "dodge": [("dodge", 1)],
    "score": [("score", 1)],
    "enter_name": [("enter_name", 1)],
}

animation_sets_specs = {
    # Format is
    #"character_name": {
    #    STATE: "animation_name",
    #    ...
    #}
    
    "double_sixteenth": {"idle": "double_sixteenth"},
    "down_eighth": {"idle": "down_eighth"},
    "up_eighth": {"idle": "up_eighth"},
    "quarter": {"idle": "quarter"},
    "half": {"idle": "half"},
    "sixteenth": {"idle": "sixteenth"},
    
    "john": {
        "idle": "john_norm",
        "hurt": "john_hurt"
    },
    
    "guitar": {
        "idle": "guitar_norm",
        "fire": "guitar_fire"
    },
    
    "sitar": {
        "idle": "sitar_norm",
        "fire": "sitar_fire"
    },
    
    "bass": {
        "idle": "bass_norm",
        "fire": "bass_fire"
    },
    
    "vocal": {
        "idle": "vocal_norm",
        "fire": "vocal_fire"
    },
    
    "no_fun": {"idle": "no_fun"},
    "norwegian_wood": {"idle": "norwegian_wood"},
    "instructions": {"idle": "instructions"},
    "press_enter": {"idle": "press_enter"},
    "axis": {"idle": "axis"},
    "local_scores": {"idle": "local_scores"},
    "global_scores": {"idle": "global_scores"},
    "credits": {"idle": "credits"},
    "dodge": {"idle": "dodge"},
    "score": {"idle": "score"},
    "enter_name": {"idle": "enter_name"},
}

bitmap_font_specs = {
    # Format is 
    #"font_name": ("font_filename", char_width, char_height)
    "default": ("font_w.png", 5, 7),
    "outline": ("font_o.png", 7, 9)
}

font_specs = {
    # Format is 
    #"font_name": ("font_filename", char_width, char_height)
    "vera_serif": ("VeraSe.ttf", 18),
    "vera_serif_small": ("VeraSe.ttf", 16),
    "vera_serif_bold": ("VeraSeBd.ttf", 18),
    "vera_serif_big": ("VeraSe.ttf", 50),
    "vera_serif_mult": ("VeraSe.ttf", 120, '1234567890?x')
}
